<template>
  <el-dialog
    v-model="dialogFormVisible"
    :title="title"
    width="500px"
    @close="close"
  >
    <el-form ref="form" :model="form" :rules="rules" label-width="100px">
      <el-form-item label="字典名称" prop="dictName">
        <el-input
          v-model.trim="form.dictName"
          size="small"
          autocomplete="off"
        ></el-input>
      </el-form-item>
      <el-form-item label="字典类型" prop="dictType">
        <el-input
          v-model.trim="form.dictType"
          size="small"
          autocomplete="off"
        ></el-input>
      </el-form-item>
    </el-form>
    <div class="dialog-footer">
      <el-button type="primary" size="small" @click="save">确 定</el-button>
      <el-button size="small" @click="close">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { doEdit, doAdd } from '@/api/sysdict';
export default {
  name: 'ManageEdit',
  data() {
    return {
      form: {
        id: '',
        dictName: '',
        dictType: '',
      },
      rules: {
        dictName: [
          { required: true, trigger: 'blur', message: '请输入字典名称' },
        ],
        dictType: [
          { required: true, trigger: 'blur', message: '请输入字典类型' },
        ],
      },
      roleData: [],
      clearable: true,
      dictId: '',
      parentData: [],
      title: '',
      dialogFormVisible: false,
      diffData: {},
      ruleForm: [],
    };
  },
  created() {},
  methods: {
    dictEdit(row) {
      if (!row) {
        this.title = '添加字典';
      } else {
        this.title = '编辑字典';
        this.dictId = row.id;
        this.form = Object.assign({}, row);
        this.ruleForm = Object.assign({}, row);
      }
      this.dialogFormVisible = true;
    },
    close() {
      this.$refs['form'].resetFields();
      this.form = this.$options.data().form;
      this.dialogFormVisible = false;
      this.$emit('fetch-data');
    },
    getDiffData() {
      this.diffData = {};
      Object.keys(this.form).forEach(item => {
        if (this.form[item] != this.ruleForm[item]) {
          this.diffData[item] = this.form[item];
        }
      });
    },
    save() {
      this.$refs['form'].validate(async valid => {
        if (valid) {
          this.form.name = this.form.title;
          if (this.form.id) {
            this.getDiffData();
            if (Object.keys(this.diffData).length != 0) {
              this.diffData.id = this.form.id;
              const { msg } = await doEdit(this.diffData);
              this.$notify({
                title: msg,
                type: 'success',
              });
            }
          } else {
            delete this.form.id;
            const { msg } = await doAdd(this.form);
            this.$notify({
              title: msg,
              type: 'success',
            });
          }
          this.$refs['form'].resetFields();
          this.dialogFormVisible = false;
          this.$parent.fetchData();
        } else {
          return false;
        }
      });
    },
  },
};
</script>
<style>
.select {
  width: 100%;
}
</style>
